#!/usr/bin/perl
# group_spam_save.cgi
# Display a list of all Proscan Anti-Virus for Mailserver settings
require './proscan-lib.pl';
require './jcode.pl';

&ReadParse();
$gr_name = $in{'grp_id'};
$notify_section = $in{'section'};

if( !(exists($in{'grp_id'})&& $in{'grp_id'} ne "") ){
	&redirect("mailscan_grp_list.cgi");
}

$config=$config{'proscan_conf'};
&lock_file($config);

$proscan_conf = get_config();
$proscan_conf->{$gr_name}{$notify_sect}{'order'} = $order unless $proscan_conf->{$gr_name}{$notify_sect}{'order'};

if( exists($in{'templ_edit_default'}) ){
	&unlock_file($proscan_config);
	$section = "smtpscan.spam_notify";
	&redirect("template_edit.cgi?grp_id=$gr_name&notify_sect=$section");
} elsif( exists($in{'templ_edit_low'}) ){
	&unlock_file($proscan_config);
	$section = "smtpscan.spam_notify.low";
	&redirect("template_edit.cgi?grp_id=$gr_name&notify_sect=$section");
} elsif( exists($in{'templ_edit_medium'}) ){
	&unlock_file($proscan_config);
	$section = "smtpscan.spam_notify.medium";
	&redirect("template_edit.cgi?grp_id=$gr_name&notify_sect=$section");
} elsif( exists($in{'templ_edit_high'}) ){
	&unlock_file($proscan_config);
	$section = "smtpscan.spam_notify.high";
	&redirect("template_edit.cgi?grp_id=$gr_name&notify_sect=$section");
} elsif( exists($in{'sub_save'}) ) {
	$proscan_conf->{$gr_name}{'smtpscan.group'}{'content'}{'SpamCheck'}=get_bool(\%in, "spam_check");
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'DracDB'}=$in{'drac_db'};
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'GrayCheck'}=get_bool(\%in, "gray_check");
	$proscan_conf->{'common'}{'path'}{'content'}{'LightGrayList'}=$in{'lightgray_list'};
	$proscan_conf->{'common'}{'path'}{'content'}{'DarkGrayList'}=$in{'darkgray_list'};
	$proscan_conf->{'common'}{'path'}{'content'}{'S25RWhiteList'}=$in{'s25r_list'};
	$proscan_conf->{'common'}{'smtpscan.limits'}{'content'}{'SpamCheckTime'}=$in{'spam_check_time'};
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'RBLcheck'}=get_bool(\%in, "rbl_check");
	
	$rbl_host = $in{'rbl'};
	$rbl_host = get_textarea_list($rbl_host,",");
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'RBLHostName'}=$rbl_host;
	
	$subj=$in{'subject_check'};
	$subj=get_textarea_list($subj,",");
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'SubjectCheck'}=$subj;
	
	$accept=$in{'wbl_accept'};
	$accept=get_textarea_list($accept,",");
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'WBLAccept'}=$accept;
	
	$reject=$in{'wbl_reject'};
	$reject=get_textarea_list($reject,",");
	$proscan_conf->{$gr_name}{'smtpscan.spam'}{'content'}{'WBLReject'}=$reject;
	
	get_notify_rule("spam_low", "low");
	#get_notify_rule("spam_medium", "medium");
	get_notify_rule("spam_high", "high");
	
	get_notify("spam_default", "default");
	get_notify("spam_low", "low");
	#get_notify("spam_medium", "medium");
	get_notify("spam_high", "high");
	
	jcode::convert(\$in{'low_msg'},'euc');
	#jcode::convert(\$in{'medium_msg'},'euc');
	jcode::convert(\$in{'high_msg'},'euc');
	
	$proscan_conf->{'common'}{'locale'}{"content"}{'SpanLowMessage'}=$in{'low_msg'};
	#$proscan_conf->{'common'}{'locale'}{"content"}{'SpamMediumMessage'}=$in{'medium_msg'};
	$proscan_conf->{'common'}{'locale'}{"content"}{'SpamHighMessage'}=$in{'high_msg'};
	
	&put_config($proscan_conf);
	&unlock_file($proscan_config_file);
	&redirect("group_spam_edit.cgi?grp_id=$in{'grp_id'}");
}

sub get_notify_rule{
	my($var_pref, $conf_pref) = @_;
	
	$section = "smtpscan.spam_action.$conf_pref";
	
	$v1=$in{"${var_pref}_add_header"};
	$subject = $in{"${var_pref}_add_subject"};
	jcode::convert(\$subject,'euc');
	$v2=$subject;
	$v3=get_bool(\%in, "${var_pref}_deliver");
	$v4=get_bool(\%in, "${var_pref}_notify");
	$v5=get_bool(\%in, "${var_pref}_save");
	$v6=$in{"${var_pref}_save_path"};
	
	$proscan_conf->{$gr_name}{$section}{'order'} = $order++ unless $proscan_conf->{$gr_name}{$section}{'order'};
	
	$proscan_conf->{$gr_name}{$section}{'content'}{'AddHeader'}=$v1;
	$proscan_conf->{$gr_name}{$section}{'content'}{'AddSubject'}=$v2;
	$proscan_conf->{$gr_name}{$section}{'content'}{'Deliver'}=$v3;
	$proscan_conf->{$gr_name}{$section}{'content'}{'Notify'}=$v4;
	$proscan_conf->{$gr_name}{$section}{'content'}{'Save'}=$v5;
	$proscan_conf->{$gr_name}{$section}{'content'}{'SavePath'}=$v6;
}

sub get_notify{
	my($var_pref, $conf_pref) = @_;
	
	if ( $conf_pref eq "default" ) {
	    $section = "smtpscan.spam_notify";
	} else {
	    $section = "smtpscan.spam_notify.$conf_pref";
	}
	
	$subject = $in{"${var_pref}_n_subj"};
	jcode::convert(\$subject,'euc');
	$v1=$subject;
	$v2=$in{"${var_pref}_n_chrset"};
	$v3=$in{"${var_pref}_n_type"};
	$v4=$in{"${var_pref}_n_templ"};
	
	$proscan_conf->{$gr_name}{$section}{'order'} = $order++ unless $proscan_conf->{$gr_name}{$section}{'order'};
	
	$proscan_conf->{$gr_name}{$section}{'content'}{'Subject'}=$v1;
	$proscan_conf->{$gr_name}{$section}{'content'}{'Charset'}=$v2;
	$proscan_conf->{$gr_name}{$section}{'content'}{'ContentType'}=$v3;
	$proscan_conf->{$gr_name}{$section}{'content'}{'Template'}=$v4;
}
